C
C * * * * * * * * * * EARTH LENGTH CONVERSIONS* * * * * * * * * * * * *
C* *
C
C
C  TRANSFORMATION FUNCTIONS FROM (LAT,LON) TO (X,Y) IN METERS
C  AND THE INVERSE FUNCTIONS.  (TAKEN FROM THE MAPS DEVELOPER GUIDE -
C  CHAPTER 6). ADDED ON OCTOBER 29, 1984, FROM STAN BENJAMIN MACROS.
C
C       M_XGRID AND M_YGRID GIVE (X,Y) AS A FUNCTION OF (LAT,LON)
C
C
C HISTORY:
C
C       K. BREWSTER 8-85
C       B. JEWETT   7-29-87     ALTERED FOR USE WITH DIFFERENT GRID DOM
CINS
C       T.L.SMITH   3-16-90     STANDARDIZED, MADE ENTRY PTS INDIVID FU
CCTIONS
C       M. BARTH    11-24-98    SENT IN GRID-DEMINITION PARAMS AS ARGS
C       M. BARTH    06-17-99    REDEFINED LON_XX (ADDED -90)
C       M. BARTH    09-15-99    COPIED FROM MSAS AND MODIFIED FOR MADIS.
C       L. BENJAMIN 06-19-08    CHANGED MADISCON INCLUDE TO INTQC1CON1
C
      FUNCTION M_YGRID(LAT,LON,Y_POLE,LAT_TRUE,LON_XX)
      INCLUDE 'IMPLICIT'
      INCLUDE 'INTQC1CON1'
      REAL M_YGRID
      REAL LAT,LON,Y_POLE,LAT_TRUE,LON_XX
C
      M_YGRID=(Y_POLE+((1.+SIN(LAT_TRUE*RADDEG_P))/
     +(1.+SIN(LAT*RADDEG_P)))*EARTH_RAD_P*COS(LAT*RADDEG_P)*
     +SIN((LON-LON_XX-90.)*RADDEG_P))
      RETURN
      END
C**---------------------------------------------------------------------
C**REQUIRED STANDARD FSL DISCLAIMER (NOVEMBER 2000)
C**---------------------------------------------------------------------
C**  OPEN SOURCE LICENSE/DISCLAIMER,  FORECAST SYSTEMS LABORATORY
C**  NOAA/OAR/FSL, 325 BROADWAY BOULDER, CO 80305
C**
C**  THIS SOFTWARE IS DISTRIBUTED UNDER THE OPEN SOURCE DEFINITION, 
C**  WHICH MAY BE FOUND AT http://www.opensource.org/osd.html.
C**
C**  IN PARTICULAR, REDISTRIBUTION AND USE IN SOURCE AND BINARY FORMS,
C**  WITH OR WITHOUT MODIFICATION, ARE PERMITTED PROVIDED THAT THE 
C**  FOLLOWING CONDITIONS ARE MET:
C**
C**  - REDISTRIBUTIONS OF SOURCE CODE MUST RETAIN THIS NOTICE, THIS LIST
C**    OF CONDITIONS AND THE FOLLOWING DISCLAIMER.
C**
C**  - REDISTRIBUTIONS IN BINARY FORM MUST PROVIDE ACCESS TO THIS 
C**    NOTICE, THIS LIST OF CONDITIONS AND THE FOLLOWING DISCLAIMER, AND
C**    THE UNDERLYING SOURCE CODE.
C**
C**  - ALL MODIFICATIONS TO THIS SOFTWARE MUST BE CLEARLY DOCUMENTED, 
C**    AND ARE SOLELY THE RESPONSIBILITY OF THE AGENT MAKING THE 
C**    MODIFICATIONS.
C**
C**  - IF SIGNIFICANT MODIFICATIONS OR ENHANCEMENTS ARE MADE TO THIS
C**    SOFTWARE, THE FSL SOFTWARE POLICY MANAGER 
C**    (softwaremgr.fsl@noaa.gov) BE NOTIFIED.
C**
C**  THIS SOFTWARE AND ITS DOCUMENTATION ARE IN THE PUBLIC DOMAIN AND 
C**  ARE FURNISHED "AS IS."  THE AUTHORS, THE UNITED STATES GOVERNMENT,
C**  ITS INSTRUMENTALITIES, OFFICERS, EMPLOYEES, AND AGENTS MAKE NO 
C**  WARRANTY, EXPRESS OR IMPLIED, AS TO THE USEFULNESS OF THE SOFTWARE
C**  AND DOCUMENTATION FOR ANY PURPOSE.  THEY ASSUME NO RESPONSIBILITY 
C**  (1) FOR THE USE OF THE SOFTWARE AND DOCUMENTATION; OR (2) TO 
C**  PROVIDE TECHNICAL SUPPORT TO USERS.
C**---------------------------------------------------------------------
